// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlSimpleLabel")]
    pub struct SimpleLabel(Object<ffi::DzlSimpleLabel, ffi::DzlSimpleLabelClass>) @extends gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_simple_label_get_type(),
    }
}

impl SimpleLabel {
    #[doc(alias = "dzl_simple_label_new")]
    pub fn new(label: &str) -> SimpleLabel {
        assert_initialized_main_thread!();
        unsafe {
            gtk::Widget::from_glib_none(ffi::dzl_simple_label_new(label.to_glib_none().0))
                .unsafe_cast()
        }
    }

    #[doc(alias = "dzl_simple_label_get_label")]
    #[doc(alias = "get_label")]
    pub fn label(&self) -> Option<glib::GString> {
        unsafe { from_glib_none(ffi::dzl_simple_label_get_label(self.to_glib_none().0)) }
    }

    #[doc(alias = "dzl_simple_label_get_width_chars")]
    #[doc(alias = "get_width_chars")]
    pub fn width_chars(&self) -> i32 {
        unsafe { ffi::dzl_simple_label_get_width_chars(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_simple_label_get_xalign")]
    #[doc(alias = "get_xalign")]
    pub fn xalign(&self) -> f32 {
        unsafe { ffi::dzl_simple_label_get_xalign(self.to_glib_none().0) }
    }

    #[doc(alias = "dzl_simple_label_set_label")]
    pub fn set_label(&self, label: &str) {
        unsafe {
            ffi::dzl_simple_label_set_label(self.to_glib_none().0, label.to_glib_none().0);
        }
    }

    #[doc(alias = "dzl_simple_label_set_width_chars")]
    pub fn set_width_chars(&self, width_chars: i32) {
        unsafe {
            ffi::dzl_simple_label_set_width_chars(self.to_glib_none().0, width_chars);
        }
    }

    #[doc(alias = "dzl_simple_label_set_xalign")]
    pub fn set_xalign(&self, xalign: f32) {
        unsafe {
            ffi::dzl_simple_label_set_xalign(self.to_glib_none().0, xalign);
        }
    }

    #[doc(alias = "label")]
    pub fn connect_label_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_label_trampoline<F: Fn(&SimpleLabel) + 'static>(
            this: *mut ffi::DzlSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::label\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_label_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "width-chars")]
    pub fn connect_width_chars_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_width_chars_trampoline<F: Fn(&SimpleLabel) + 'static>(
            this: *mut ffi::DzlSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::width-chars\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_width_chars_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }

    #[doc(alias = "xalign")]
    pub fn connect_xalign_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_xalign_trampoline<F: Fn(&SimpleLabel) + 'static>(
            this: *mut ffi::DzlSimpleLabel,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(&from_glib_borrow(this))
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::xalign\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_xalign_trampoline::<F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl fmt::Display for SimpleLabel {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("SimpleLabel")
    }
}
